#include	"dmonitor.h"

//USE WIRINGPI PIN NUMBERS
#define LCD_RS  10               //Register select pin	GPIO10
#define LCD_E   9               //Enable Pin		GPIO9
#define LCD_D4  11               //Data pin 4		GPIO11
#define LCD_D5  25               //Data pin 5		GPIO25
#define LCD_D6  8               //Data pin 6		GPIO8
#define LCD_D7  7               //Data pin 7		GPIO7

/* bit pattern to feed into lcdCharDef to define a new character */

static unsigned char NewChar_1 [8] =
{
  0b00000,
  0b10000,
  0b01000,
  0b00100,
  0b00010,
  0b00001,
  0b00000,
  0b00000,
} ;

static unsigned char NewChar_2 [8] =
{
  0b00000,
  0b00000,
  0b00000,
  0b11111,
  0b00000,
  0b00000,
  0b00000,
  0b00000,
} ;
 
void lcd_init()
{
	if (lcd_type == NONE)
	{
		return;
	}
	else if (lcd_type = LCD_20x4)
	{
		lcd = lcdInit (4, 20, 4, LCD_RS, LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7, 
			0, 0, 0, 0);
	}
	else if (lcd_type == LCD_16x2)
	{
		lcd = lcdInit (2, 16, 4, LCD_RS, LCD_E, LCD_D4, LCD_D5, LCD_D6, LCD_D7,
			0, 0, 0, 0);
	}
	usleep (100);
	lcdClear (lcd);
	usleep (3000);
	lcdCharDef (lcd, 1, NewChar_1);
	lcdCharDef (lcd, 2, NewChar_2);
}

